<?php
namespace Estoque\Logic\AtualizacaoEstoque\Exceptions;

/**
 * Itens irregulares no Estoque.
 */
class ProdutoEstoqueIrregular extends \Estoque\Logic\Exception
{

    private $produtos = array();

    /**
     * @param array $produtos
     * @param string $message
     * @param int $code
     * @param \Exception|null $previous
     */
    public function __construct(array $produtos, $message = "", $code = 0, \Exception $previous = null)
    {
        $this->produtos = $produtos;
        parent::__construct($message, $code, $previous);

        $stringProdutos = "";
        foreach ($this->produtos as $produto) {
            $stringProdutos .= "<br>$produto";
        }

        $this->addParam($produtos);
    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return "msg_irregularidade_estoque";
    }

}
